// dmo pour afficheur LCD graphique GDM12864A sur microcontroleur MICROCHIP PIC
// C.Dupaty 04-2003
// ralise  partir d'une tude de Pascal Stang pour ATMEL AVR

#include <p18f452.h>
#include "glcdpiclib.c" // librairie grapghique pour PIC accompagge de font5x7.h et fontgr.h
#include "logo.c"
#include "pompe.c"

#define LIGNE1		0
#define LIGNE2		1
#define LIGNE3		2
#define LIGNE4		3
#define LIGNE5		4
#define LIGNE6		5
#define LIGNE7		6
#define LIGNE8		7

//--------------------------------------------------------------------------------------------------------
// tests des fonctions graphiques

void lcdtest(void)
{unsigned char i ;
// criture d'un caractre
	glcdSetAddress(50,LIGNE2);
	glcdWriteChar('H');
	glcdWriteChar('E');
	glcdWriteChar('L');
	glcdWriteChar('L');
	glcdWriteChar('O');
	glcdDelay(0xFFFF);
	
	glcdClearScreen();

// criture de chaines de caractres
	glcdSetAddress(4,LIGNE2);
	glcdPutStr("Afficheur graphique");
	glcdSetAddress(4,LIGNE3);
	glcdPutStr("GDM12864A");
	glcdSetAddress(4,LIGNE5);
	glcdPutStr("controle par");
	glcdSetAddress(4,LIGNE6);
	glcdPutStr("Microchip PIC");
	glcdRectangle(0, 0, 64, 128,1);
  	glcdDelay(0xFFFF);
  	glcdDelay(0xFFFF);
  
			glcdSetAddress(4,LIGNE7);
			glcdDelay(0xFFFF);
			
			// allumage et extinction d'un pixel
			glcdClearScreen();	
			for ( i=0; i<=127; i+=3)
			{
				glcdSetDot(i,63 - i/2);
  				glcdDelay(d1);
			}
			for ( i=0; i<128; i+=3)
			{
				glcdClearDot(i,63 - i/2);
  				glcdDelay(d1);
			}
		
			// tracs de cercles		
			glcdClearScreen();	
  			glcdCircle(25,20,17,1);
  			glcdDelay(d2);
  			glcdCircle(90,30,15,1);
  			glcdDelay(d2);
  			glcdCircle(55,30,23,1);
  			glcdDelay(d2);
  			glcdCircle(100,48,15,1);
  			glcdDelay(d2);
  			glcdCircle(34,50,10,1);
  			glcdDelay(d2);
  			glcdCircle(60,55,8,1);
		     
			glcdDelay(0xFFFF);
			
			//trac de rectangles
			glcdClearScreen();	
			glcdRectangle(54, 41, 6 , 12,1);
  			glcdDelay(d2);
			glcdRectangle(34, 12, 32, 2,1);
  			glcdDelay(d2);
			glcdRectangle(23, 34, 17, 21,1);
  			glcdDelay(d2);
			glcdRectangle(62, 20, 42, 58,1);
  			glcdDelay(d2);
			glcdRectangle(4 , 30, 12, 12,1);
				
			glcdDelay(0xFFFF);
			
			//choix des lignes	
			glcdClearScreen();	
			glcdSetAddress(0,LIGNE1);	
			glcdPutStr("LIGNE 1"); glcdDelay(d2);
			glcdSetAddress(10,LIGNE2);
			glcdPutStr("LIGNE 2"); glcdDelay(d2);
			glcdSetAddress(20,LIGNE3);
			glcdPutStr("LIGNE 3"); glcdDelay(d2);
			glcdSetAddress(30,LIGNE4);
			glcdPutStr("LIGNE 4"); glcdDelay(d2);
			glcdSetAddress(40,LIGNE5);
			glcdPutStr("LIGNE 5"); glcdDelay(d2);
			glcdSetAddress(50,LIGNE6);
			glcdPutStr("LIGNE 6"); glcdDelay(d2);
			glcdSetAddress(60,LIGNE7);
			glcdPutStr("LIGNE 7"); glcdDelay(d2);
			glcdSetAddress(70,LIGNE8);
			glcdPutStr("LIGNE 8"); glcdDelay(d2);
		
			glcdDelay(0xFFFF);
		
			// test de la police et de la fonction de dcalage
			glcdClearScreen();	
			glcdSetAddress(0,LIGNE2);
  			glcdPutStr(" !");
  			glcdWriteChar('"');
  			glcdPutStr("#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  			glcdPutStr("[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~");
		
			glcdDelay(0xFFFF);
		
			for (i=0; i<64; i++)
			{
				glcdStartLine(64- i - 1);
  				glcdDelay(d1);
			}
				
			glcdDelay(0xFFFF);
		
			for (i=0; i<64; i++)
			{
				glcdStartLine(i + 1);
  				glcdDelay(d1);
			}

		// trac de lignes			
			glcdClearScreen();	
			for (i=0;i<65;i+=10)
			{glcdLine(0,0,120,i,1);
			 glcdDelay(d2);
			 }
			for (i=0;i<65;i+=10)
			{glcdLine(0,0,120,i,0);
			 glcdDelay(d2);
			 }
		glcdDelay(d1);
		 trace_logo(10,1, 29,40,pompe_data);

 
}


 //---------------------------------------------------------------------------------------------------------

void main(void)
{	
	glcdInit();

	while(1) lcdtest();
	
}

