// l'image doit avoir pour hauteur un multiple de 8 ex 55x48.bmp (48=6x8) (pour affichage complet)
// 
// x,y coordonnes sur LCD , largeur, hauteur dimensions image en pixels
// 0<x<128
// 0<y<8 (decalage ligne uniquement)
// data adresse de l'image (voir exemple)
// void trace_logo(unsigned char x,unsigned char y,unsigned char largeur,unsigned char hauteur,rom unsigned char* data)


void ecr_data(char ddata)  	// envoi de l'octet vers lcd
   {
   LCD_CTRL_RS=1;		  		// vers registre donnes
   LCD_DATA_PORT=ddata;        
   LCD_CTRL_E=1;           		// validation  
   LCD_CTRL_E=0;
   }

void ecr_ctrl(char dctrl)  	// envoi de l'octet vers lcd
   {
   LCD_CTRL_RS=0;				// vers registre de controle
   LCD_DATA_PORT=dctrl;        
   LCD_CTRL_E=1;         		// validation  
   LCD_CTRL_E=0;
   }
   
void chip(unsigned char cs)	// 0 pour gauche,  1 pour droite
{
	LCD_CTRL_CS0=!cs; 
	LCD_CTRL_CS1=cs; 
} 


// x,y coordonnes sur LCD , largeur, hauteur dimensions image en pixels
// 0<x<128
// 0<y<8 (decalage ligne)
// data adresse de l'image
void trace_logo(unsigned char x,unsigned char y,unsigned char largeur,unsigned char hauteur,rom unsigned char* data)
{
unsigned char ligne,pix,posx;
	y-=1;	// ajustement, ligne 1 commence en 0
  for(ligne=0;ligne<(hauteur/8);ligne++)
   {
		chip(1);
		ecr_ctrl(0x40);     	// initialise ctrl1 sur colonne 0 par defaut
        ecr_ctrl(0xB8+y+ligne); // page origine sur ctrl1
        posx=x;
		if (posx<64) 		// quel est le ctrl concerne ?
			{		
				chip(0);   
			    ecr_ctrl(0x40+x);     	// colonne
		        ecr_ctrl(0xB8+y+ligne); // page ++
			}
		else
			{ 
				chip(1);
				ecr_ctrl(0x40+x-64);     	// colonne
		        ecr_ctrl(0xB8+y+ligne); // page ++
			}


	   	for(pix=0;pix<largeur;pix++)
				{
				if (posx<64) chip(0); else chip(1);		// choix cot
				ecr_data(*data++);  // envoie donnes
				posx++;
				}
   }
}
